// Resolución de sudokus con técnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaración de la clase MarcasCasillas

#ifndef MARCASCASILLAS_H
#define MARCASCASILLAS_H

class MarcasCasillas {
    private:
    bool casillas[9];

    public:
    MarcasCasillas()                                    /**< Constructor */
        { Borra(); }
    MarcasCasillas(const MarcasCasillas &m)             /**< Constructor copia */
        { for(int i=0; i<9; i++) casillas[i] = m.casillas[i]; }
    void Borra()                                        /**< Borra todas las marcas */
        { for(int i=0; i<9; i++) casillas[i] = false; }
    void AsignaCasilla(int c)                           /**< Marca la casilla c */
        { casillas[c] = true; }
    int CuentaCasillas();                               /**< Cuenta las casillas marcadas */
    bool ContieneCasilla(int c)                         /**< Devuelve true si la casilla c está marcada */
        { return casillas[c]; }
    MarcasCasillas &operator=(const MarcasCasillas &m1) /**< Operador de asignación */
        { for(int i=0; i<9; i++) casillas[i] = m1.casillas[i]; return *this; };
    MarcasCasillas operator+(const MarcasCasillas &m1); /**< Operador de suma */
    MarcasCasillas operator~();                         /**< Operador de negación (invierte todos los valores) */
    MarcasCasillas operator&(const MarcasCasillas &m1); /**< Operador AND */
    int Cajas();
    int Casilla();
    void MascaraCaja(int k);
};

#endif // MARCASCASILLAS_H
