// Sudokus con Clase
// Resolución de sudokus con técnicas reales
// (C) 2023 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaración de la clase Oculto
//
// Se usa para detectar parejas, trios, cuartetos... ocultos

#ifndef OCULTO_H
#define OCULTO_H

#include "casilla.h"
#include "marcaslapiz.h"
#include "combinaciones.h"

class Oculto {
    private:
    int valor[9];                                   /**< Valores del grupo */
    Combinacion<Casilla *> comb;                    /**< Combinaciones de casillas */

    public:
    Oculto(Casilla *c[9]) : comb(c, 9) {}           /**< Constructor */
    bool PrimeraCombinacion(int nElementos)         /**< Obtiene la primera combinación de valores */
        { return comb.PrimeraCombinacion(nElementos); }
    bool SiguienteCombinacion()                     /**< Obtiene las siguientes combinaciones a partir de la primera */
        { return comb.SiguienteCombinacion(); }
    Casilla *Comb(int index) const                  /**< Obtiene la casilla correspondiente a la posición index de la combinación actual */
        { return comb.Comb()[index]; }
    bool Contiene(Casilla *cas, int nElementos);    /**< Devuelve true si la combinación actual contiene la casilla indicada */
    char *Casillas(int);                            /**< Obtiene las casillas de la combinación actual como una cadena */
    char *Valores(MarcasLapiz marcas, int);         /**< Obtiene los valores de la combinación actual como una cadena */
};

#endif // OCULTO_H
