// Sudokus con Clase
// Resolución de sudokus con técnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaración de la clase Pareja

#ifndef PAREJA_H
#define PAREJA_H

#include "casilla.h"

class Pareja {
private:
    Casilla *cas[2];        /**< Almacena una pareja de punteros a casilla */

public:
    Pareja() { cas[0] = cas[1] = nullptr; }                 /**< Constructor */
    Casilla *Cas(int c) { return cas[c]; }                  /**< Devuelve el puntero al elemento c de la pareja */
    void Asigna(int p, Casilla *c)                          /**< Asigna la casilla a la posición p de la pareja */
        { if(p < 2) cas[p] = c; };
    bool MismaCaja()                                        /**< Devuelve true si las dos casillas pertenecen a la misma caja */
        { return cas[0]->Caja() == cas[1]->Caja(); }
    bool MismaFila()                                        /**< Devuelve true si las dos casillas pertenecen a la misma fila */
        { return cas[0]->Fila() == cas[1]->Fila(); }
    bool MismaColumna()                                     /**< Devuelve true si las dos casillas pertenecen a la misma columna */
        { return cas[0]->Columna() == cas[1]->Columna(); }
};

#endif // PAREJA_H
