// Sudokus con Clase
// Resolución de sudokus con técnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaración de la clase Unico

#ifndef UNICO_H
#define UNICO_H

/** \brief Clase Unico
 *
 * Contiene información sobre una fila, columna o caja con una única casilla sin valor definido
 *
 */

class Unico {
    private:
    int casilla;            /**< Número de orden de la única casilla sin valor final o -1 */
    int valor;              /**< El valor que falta, y que debe pertenecer a esa casilla, o 0 */
    public:
    Unico(int c, int v) : casilla(c), valor(v) {}   /**< Constructor */
    int Casilla() { return casilla; }               /**< Obtiene el valor de la casilla */
    int Valor() { return valor; }                   /**< Obtiene el valor que se debe asignar a esa casilla */
};

#endif // UNICO_H
