// Sudokus con Clase
// Resolución de sudokus con técnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Definición de la clase Columna

#include "columna.h"
#include "tablero.h"

void Columna::Iniciar(Tablero &t, int c) {
    for(int i = 0; i < 9; i++) cas[i] = &t.GetCasilla(i, c);
}

Casilla *Columna::DobleCandidatoYMas(Pareja par, int v) {
    bool presA, presB, presC;
    int f1, f2;

    f1 = par.Cas(0)->Fila();
    f2 = par.Cas(1)->Fila();
    // Verificamos si la las columnas de la pareja par tienen el candidato v
    if(cas[f1]->Lapiz().ContieneMarca(v) && cas[f2]->Lapiz().ContieneMarca(v)) {
        // Verificamos si el candidato esta presente en una o dos casillas de la misma fila y caja
        // De cada una de las columnas.
        presA = presB = presC = false;
        for(int f=0; f<9; f++) {
            // Si la casilla contiene el candidato, pero no forma parte del X-Wing
            if(f!=f1 && f!=f2 && cas[f]->Lapiz().ContieneMarca(v)) {
                if(cas[f]->Caja() == cas[f1]->Caja()) presA = true; // Es un ala de par(0)
                else
                if(cas[f]->Caja() == cas[f2]->Caja()) presB = true; // Es un ala de par(1)
                else presC = true; // Presencia en caja diferente
            }
        }
        // Si solo hay alas en par(0) o par(1) retornamos la caja a la que pertenecen el o las alas
        if(presC) return nullptr;
        if(presA && !presB) return cas[f1];
        if(!presA && presB) return cas[f2];
    }
    return nullptr;
}
