// Sudokus con Clase
// Resolución de sudokus con técnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Definición de la clase Fila

#include "fila.h"
#include "tablero.h"

void Fila::Iniciar(Tablero &t, int f) {
    for(int i = 0; i < 9; i++) cas[i] = &t.GetCasilla(f, i);
}

Casilla *Fila::DobleCandidatoYMas(Pareja par, int v) {
    bool presA, presB, presC;
    int c1, c2;

    c1 = par.Cas(0)->Columna();
    c2 = par.Cas(1)->Columna();
    // Verificamos si la las columnas de la pareja par tienen el candidato v
    if(cas[c1]->Lapiz().ContieneMarca(v) && cas[c2]->Lapiz().ContieneMarca(v)) {
        // Verificamos si el candidato esta presente en una o dos casillas de la misma fila y caja
        // De cada una de las columnas.
        presA = presB = presC = false;
        for(int c=0; c<9; c++) {
            // Si la casilla contiene el candidato, pero no forma parte del X-Wing
            if(c!=c1 && c!=c2 && cas[c]->Lapiz().ContieneMarca(v)) {
                if(cas[c]->Caja() == cas[c1]->Caja()) presA = true; // Es un ala de par(0)
                else
                if(cas[c]->Caja() == cas[c2]->Caja()) presB = true; // Es un ala de par(1)
                else presC = true; // Presencia en caja diferente
            }
        }
        // Si solo hay alas en par(0) o par(1) retornamos la caja a la que pertenecen el o las alas
        if(presC) return nullptr;
        if(presA && !presB) return cas[c1];
        if(!presA && presB) return cas[c2];
    }
    return nullptr;
}
