// Sudokus con Clase
// Resolución de sudokus con técnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Definición de la clase MarcasCasillas

#include "marcascasillas.h"

int MarcasCasillas::CuentaCasillas() {
    int cuenta=0;
    for(int c=0; c<9; c++) if(casillas[c]) cuenta++;
    return cuenta;
}

MarcasCasillas MarcasCasillas::operator+(const MarcasCasillas &m1) {
    MarcasCasillas res;
    for(int i=0; i<9; i++) res.casillas[i] = this->casillas[i] || m1.casillas[i];
    return res;
}

MarcasCasillas MarcasCasillas::operator~() {
    MarcasCasillas res;
    for(int i=0; i<9; i++) res.casillas[i] = !this->casillas[i];
    return res;
}

MarcasCasillas MarcasCasillas::operator&(const MarcasCasillas &m1) {
    MarcasCasillas res;
    for(int i=0; i<9; i++) res.casillas[i] = this->casillas[i] && m1.casillas[i];
    return res;
}

int MarcasCasillas::Cajas() {
    int retval = 0;

    if(casillas[0] || casillas[1] || casillas[2]) retval += 0x01; // Primera caja 001
    if(casillas[3] || casillas[4] || casillas[5]) retval += 0x02; // Segunda caja 010
    if(casillas[6] || casillas[7] || casillas[8]) retval += 0x04; // Tercera caja 100
    return retval;
}

int MarcasCasillas::Casilla() {
    for(int c=0; c<9; c++) if(ContieneCasilla(c)) return c;
    return -1;
}

void MarcasCasillas::MascaraCaja(int k) {
    if(!(k & 0x01)) {
        casillas[0] = false;
        casillas[1] = false;
        casillas[2] = false;
    }
    if(!(k & 0x02)) {
        casillas[3] = false;
        casillas[4] = false;
        casillas[5] = false;
    }
    if(!(k & 0x04)) {
        casillas[6] = false;
        casillas[7] = false;
        casillas[8] = false;
    }

    //if(k <= 2) casillas &= (7 << k*3);
}
