#include "oculto.h"

// Sudokus con Clase
// Resolución de sudokus con técnicas reales
// (C) 2023 Salvador Pozo
// Con Clase https://conclase.net
//
// Definición de la clase Oculto

#include "grupo.h"

bool Oculto::Contiene(Casilla *cas, int nElementos) {
    for(int i=0; i<nElementos; i++) {
        if(comb.Comb()[i] == cas) return true;
    }
    return false;
}

char *Oculto::Casillas(int nElementos) {
    static char cad[64];

    for(int i=0; i<nElementos; i++) {
        cad[i*3] = 'A'+comb.Comb()[i]->Fila();
        cad[i*3+1] = '1'+comb.Comb()[i]->Columna();
        cad[i*3+2] = ' ';
    }
    cad[3*nElementos] = 0;
    return cad;
}

char *Oculto::Valores(MarcasLapiz marcas, int nElementos) {
    static char cad[64];

    for(int i=0,v=1; v<=9; v++) {
        if(marcas.ContieneMarca(v)) {
            cad[i*2] = '0'+v;
            cad[i*2+1] = ' ';
            i++;
        }
    }
    cad[2*nElementos] = 0;
    return cad;
}

