/***************************************************************
 * Name:      sudokuMain.h
 * Purpose:   Defines Application Frame
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2025-01-11
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifndef SUDOKUMAIN_H
#define SUDOKUMAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <wx/file.h>
#include <wx/dcbuffer.h>
#include <sqlite3.h>
#include <thread>
#include "sudokuApp.h"
#include "lista.h"
#include "casilla.h"
#include "tablero.h"

class sudokuFrame: public wxFrame
{
    public:
        sudokuFrame(wxFrame *frame, const wxString& title);
        ~sudokuFrame();
    private:
        unsigned char tablero[82] = {
            "600000270070420630004030000030002157090100000080000000208600003060800009100000005"
        };
        Tablero T;
        int valor;
        enum
        {
            idMenuQuit = 1000,
            idMenuAbout,
            idMenuLoad,
            idMenuImportar,
            idMenuReiniciar,
            idMenuResolver,
            idMenuAutomatico,
            idTextCtrl,
            idListBox
        };
        wxTextCtrl *tecnica;
        wxListBox *log;
        int rc;
        sqlite3 *db;
        sqlite3_stmt *ppStmt;
        bool ejecutandoHilo;
        void Load(wxCommandEvent& event);
        void Importar(wxCommandEvent& event);
        void Comprobar();
        void Resolver(wxCommandEvent& event);
        void Automatico(wxCommandEvent& event);
        void Paso();
        void Reiniciar(wxCommandEvent& event);
        void Log();
        void OnClose(wxCloseEvent& event);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnPaint(wxPaintEvent& event);
        void MuestraValor(wxDC& dc, int lado, Casilla& cas);
        void MuestraMarcasDeLapiz(wxDC& dc, int lado, Casilla &cas);
        DECLARE_EVENT_TABLE()
};


#endif // SUDOKUMAIN_H
